/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.records;


import com.tabajara.base.tables.Horarepeticao;
import com.tabajara.base.tables.interfaces.IHorarepeticao;

import io.github.jklingsporn.vertx.jooq.shared.internal.VertxPojo;

import java.sql.Date;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record5;
import org.jooq.Row5;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class HorarepeticaoRecord extends UpdatableRecordImpl<HorarepeticaoRecord> implements VertxPojo, Record5<Integer, String, Date, Integer, String>, IHorarepeticao {

    private static final long serialVersionUID = -1684345619;

    /**
     * Setter for <code>public.horarepeticao.horid</code>.
     */
    @Override
    public HorarepeticaoRecord setHorid(Integer value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>public.horarepeticao.horid</code>.
     */
    @Override
    public Integer getHorid() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>public.horarepeticao.horhora</code>.
     */
    @Override
    public HorarepeticaoRecord setHorhora(String value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>public.horarepeticao.horhora</code>.
     */
    @Override
    public String getHorhora() {
        return (String) get(1);
    }

    /**
     * Setter for <code>public.horarepeticao.hordiainicial</code>.
     */
    @Override
    public HorarepeticaoRecord setHordiainicial(Date value) {
        set(2, value);
        return this;
    }

    /**
     * Getter for <code>public.horarepeticao.hordiainicial</code>.
     */
    @Override
    public Date getHordiainicial() {
        return (Date) get(2);
    }

    /**
     * Setter for <code>public.horarepeticao.horrepetiracada</code>.
     */
    @Override
    public HorarepeticaoRecord setHorrepetiracada(Integer value) {
        set(3, value);
        return this;
    }

    /**
     * Getter for <code>public.horarepeticao.horrepetiracada</code>.
     */
    @Override
    public Integer getHorrepetiracada() {
        return (Integer) get(3);
    }

    /**
     * Setter for <code>public.horarepeticao.hortiporepeticao</code>.
     */
    @Override
    public HorarepeticaoRecord setHortiporepeticao(String value) {
        set(4, value);
        return this;
    }

    /**
     * Getter for <code>public.horarepeticao.hortiporepeticao</code>.
     */
    @Override
    public String getHortiporepeticao() {
        return (String) get(4);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record5 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row5<Integer, String, Date, Integer, String> fieldsRow() {
        return (Row5) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row5<Integer, String, Date, Integer, String> valuesRow() {
        return (Row5) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field1() {
        return Horarepeticao.HORAREPETICAO.HORID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field2() {
        return Horarepeticao.HORAREPETICAO.HORHORA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Date> field3() {
        return Horarepeticao.HORAREPETICAO.HORDIAINICIAL;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field4() {
        return Horarepeticao.HORAREPETICAO.HORREPETIRACADA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field5() {
        return Horarepeticao.HORAREPETICAO.HORTIPOREPETICAO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component1() {
        return getHorid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component2() {
        return getHorhora();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Date component3() {
        return getHordiainicial();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component4() {
        return getHorrepetiracada();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component5() {
        return getHortiporepeticao();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value1() {
        return getHorid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value2() {
        return getHorhora();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Date value3() {
        return getHordiainicial();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value4() {
        return getHorrepetiracada();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value5() {
        return getHortiporepeticao();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HorarepeticaoRecord value1(Integer value) {
        setHorid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HorarepeticaoRecord value2(String value) {
        setHorhora(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HorarepeticaoRecord value3(Date value) {
        setHordiainicial(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HorarepeticaoRecord value4(Integer value) {
        setHorrepetiracada(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HorarepeticaoRecord value5(String value) {
        setHortiporepeticao(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HorarepeticaoRecord values(Integer value1, String value2, Date value3, Integer value4, String value5) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        return this;
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public void from(IHorarepeticao from) {
        setHorid(from.getHorid());
        setHorhora(from.getHorhora());
        setHordiainicial(from.getHordiainicial());
        setHorrepetiracada(from.getHorrepetiracada());
        setHortiporepeticao(from.getHortiporepeticao());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public <E extends IHorarepeticao> E into(E into) {
        into.from(this);
        return into;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached HorarepeticaoRecord
     */
    public HorarepeticaoRecord() {
        super(Horarepeticao.HORAREPETICAO);
    }

    /**
     * Create a detached, initialised HorarepeticaoRecord
     */
    public HorarepeticaoRecord(Integer horid, String horhora, Date hordiainicial, Integer horrepetiracada, String hortiporepeticao) {
        super(Horarepeticao.HORAREPETICAO);

        set(0, horid);
        set(1, horhora);
        set(2, hordiainicial);
        set(3, horrepetiracada);
        set(4, hortiporepeticao);
    }

    public HorarepeticaoRecord(io.vertx.core.json.JsonObject json) {
        this();
        fromJson(json);
    }
}
